/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.BreastGYNMammoSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_DepthFromBI_RADS;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_DepthFromBI_RADS;


/**
 * This class represents DepthFromBI - RADS_CID6025
 */
public class DepthFromBI_RADS_CID6025 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new DepthFromBI_RADS_CID6025 Template 
	 */
	public DepthFromBI_RADS_CID6025()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumDepthFromBI_RADS Object of EnumCM_DepthFromBI_RADS represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_DepthFromBI_RADS enumDepthFromBI_RADS)
	{
		switch(enumDepthFromBI_RADS)
		{
		case ANTERIOR: this.strCodeValue =EnumCV_DepthFromBI_RADS.ANTERIOR_G_A105.getValue(); break;
		case MIDDLE: this.strCodeValue =EnumCV_DepthFromBI_RADS.MIDDLE_G_A109.getValue(); break;
		case POSTERIOR: this.strCodeValue =EnumCV_DepthFromBI_RADS.POSTERIOR_G_A106.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumDepthFromBI_RADS Object of EnumCM_DepthFromBI_RADS represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_DepthFromBI_RADS enumDepthFromBI_RADS)
	{
		switch(enumDepthFromBI_RADS)
		{
		case ANTERIOR : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.ANTERIOR.getSNOMEDCTID(); break;
		case MIDDLE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.MIDDLE.getSNOMEDCTID(); break;
		case POSTERIOR : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.POSTERIOR.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for DepthFromBI_RADS
	 * @param enumDepthFromBI_RADS Object of EnumCM_DepthFromBI_RADS.
	 */
	public void setDepthFromBI_RADS(EnumCM_DepthFromBI_RADS enumDepthFromBI_RADS)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumDepthFromBI_RADS.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumDepthFromBI_RADS);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumDepthFromBI_RADS);
	}
}
